"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deprecate = exports.assert = exports.env = void 0;
exports.env = process.env;
function assert(ctx, value, method) {
    if (ctx[value] === undefined) {
        throw new TypeError(`Telegraf: "${method}" isn't available for "${ctx.updateType}"`);
    }
}
exports.assert = assert;
function deprecate(method, ignorable, use, see) {
    const ignorer = `IGNORE_DEPRECATED_${ignorable}`;
    if (exports.env[ignorer])
        return;
    const stack = { stack: '' };
    Error.captureStackTrace(stack);
    const line = (stack.stack.split('\n')[3] || '').trim();
    const useOther = use ? `; use ${use} instead` : '';
    const pad = ' '.repeat('[WARN]'.length);
    console.warn(`[WARN] ${method} is deprecated${useOther}`);
    if (line)
        console.warn(pad, line);
    if (see)
        console.warn(pad, `See ${see}`);
}
exports.deprecate = deprecate;
